// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QPDFRender.pas' rev: 5.00

#ifndef QPDFRenderHPP
#define QPDFRenderHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Graphics.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qpdfrender
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TRenderTextAlign { rtaLeft, rtaRight, rtaCenter, rtaJustify, rtaTerminal };
#pragma option pop

#pragma option push -b-
enum TRenderVerticalAlign { rvaTop, rvaCenter, rvaBottom };
#pragma option pop

class DELPHICLASS TRenderWriter;
class PASCALIMPLEMENTATION TRenderWriter : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	int DrawThinkness;
	int DrawColor;
	int CurPageNum;
	int TotalPages;
	__fastcall TRenderWriter(void);
	virtual void __fastcall DrawLine(int x, int y, int x2, int y2) = 0 ;
	virtual void __fastcall DrawRect(int x, int y, int width, int height) = 0 ;
	virtual void __fastcall FillRect(int x, int y, int width, int height, int color) = 0 ;
	virtual void __fastcall DrawWord(int x, int y, WideString Word, Graphics::TFont* Font) = 0 ;
	virtual void __fastcall DrawImage(int x, int y, int width, int height, Graphics::TGraphic* Image, bool 
		Raster) = 0 ;
	virtual void __fastcall SetLink(AnsiString Target, const Windows::TRect &Bounds) = 0 ;
	virtual void __fastcall ResolveLink(AnsiString Target, int X, int Y) = 0 ;
	virtual void __fastcall SetClip(int x, int y, int width, int height) = 0 ;
	virtual void __fastcall RemoveClip(void) = 0 ;
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TRenderWriter(void) { }
	#pragma option pop
	
};


class DELPHICLASS TRenderItems;
class DELPHICLASS TRenderAtom;
class PASCALIMPLEMENTATION TRenderItems : public Contnrs::TObjectList 
{
	typedef Contnrs::TObjectList inherited;
	
private:
	TRenderAtom* __fastcall GetItems(int Index);
	void __fastcall SetItems(int Index, const TRenderAtom* Value);
	
protected:
	__property TRenderAtom* Items[int Index] = {read=GetItems, write=SetItems/*, default*/};
public:
	#pragma option push -w-inl
	/* TObjectList.Create */ inline __fastcall TRenderItems(void)/* overload */ : Contnrs::TObjectList(
		) { }
	#pragma option pop
	
public:
	#pragma option push -w-inl
	/* TList.Destroy */ inline __fastcall virtual ~TRenderItems(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TRenderSplitMode { splitTest, splitRegular, splitForced };
#pragma option pop

class DELPHICLASS TRenderCell;
class PASCALIMPLEMENTATION TRenderAtom : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	int FX;
	int FY;
	int FWidth;
	int FHeight;
	TRenderAtom* FParent;
	TRenderCell* FCell;
	int FHSpacing;
	virtual int __fastcall GetHeight(void);
	int __fastcall ParentColor(void);
	virtual int __fastcall XWidth(void);
	
protected:
	__fastcall TRenderAtom(int _Width, TRenderAtom* _Parent)/* overload */;
	virtual void __fastcall Draw(TRenderWriter* Writer, int X, int Y);
	virtual void __fastcall DrawOutline(TRenderWriter* Writer, int X, int Y);
	virtual TRenderAtom* __fastcall Split(int Y, TRenderSplitMode mode);
	__property TRenderAtom* Parent = {read=FParent};
	
public:
	int BgColor;
	AnsiString LinkTarget;
	AnsiString LinkName;
	__fastcall TRenderAtom(int _Width)/* overload */;
	__fastcall virtual ~TRenderAtom(void);
	__property int Height = {read=GetHeight, nodefault};
	__property int Width = {read=FWidth, nodefault};
};


class DELPHICLASS TRenderRow;
class PASCALIMPLEMENTATION TRenderCell : public TRenderAtom 
{
	typedef TRenderAtom inherited;
	
public:
	TRenderItems* FAtoms;
	Graphics::TMetafile* FMetaFile;
	Graphics::TMetafileCanvas* FMetaCanvas;
	virtual int __fastcall GetHeight(void);
	TRenderRow* __fastcall GetParent(void);
	Windows::TRect __fastcall GetPadding();
	
protected:
	__fastcall TRenderCell(int _Width, TRenderRow* _Row);
	virtual void __fastcall Draw(TRenderWriter* Writer, int X, int Y);
	virtual void __fastcall DrawOutline(TRenderWriter* Writer, int X, int Y);
	virtual TRenderAtom* __fastcall Split(int Y, TRenderSplitMode mode);
	__property TRenderItems* Atoms = {read=FAtoms};
	__property TRenderRow* Parent = {read=GetParent};
	
public:
	int BorderLeft;
	int BorderRight;
	int BorderTop;
	int BorderBottom;
	int Indent;
	Windows::TRect Padding;
	TRenderVerticalAlign VerticalAlign;
	__fastcall virtual ~TRenderCell(void);
	Graphics::TCanvas* __fastcall Canvas(void);
	int __fastcall InternalWidth(void);
	void __fastcall AddText(WideString _Text, Graphics::TFont* _Font, TRenderTextAlign _Align, AnsiString 
		_Link);
	void __fastcall AddTextItem(TRenderAtom* _Item);
	void __fastcall AddItem(int X, int Y, TRenderAtom* Item);
	TRenderCell* __fastcall AddParagraph(void);
};



class DELPHICLASS TRenderTable;
class PASCALIMPLEMENTATION TRenderRow : public TRenderAtom 
{
	typedef TRenderAtom inherited;
	
private:
	int FForceHeight;
	TRenderItems* FCells;
	virtual int __fastcall GetHeight(void);
	TRenderTable* __fastcall GetParent(void);
	TRenderCell* __fastcall GetCell(int Index);
	int __fastcall GetCellCount(void);
	
protected:
	__fastcall TRenderRow(int _Width, TRenderTable* _Table);
	virtual void __fastcall Draw(TRenderWriter* Writer, int X, int Y);
	virtual void __fastcall DrawOutline(TRenderWriter* Writer, int X, int Y);
	__property TRenderTable* Parent = {read=GetParent};
	virtual TRenderAtom* __fastcall Split(int Y, TRenderSplitMode mode);
	
public:
	__fastcall virtual ~TRenderRow(void);
	__property TRenderCell* Cell[int Index] = {read=GetCell};
	__property int CellCount = {read=GetCellCount, nodefault};
};


typedef DynamicArray<int >  QPDFRender__7;

class PASCALIMPLEMENTATION TRenderTable : public TRenderAtom 
{
	typedef TRenderAtom inherited;
	
private:
	TRenderItems* FRows;
	DynamicArray<int >  FColWidths;
	bool FSplitted;
	virtual int __fastcall GetHeight(void);
	TRenderCell* __fastcall GetCells(int x, int y);
	TRenderRow* __fastcall GetRow(int Index);
	int __fastcall GetRowCount(void);
	
protected:
	__fastcall TRenderTable(const int * _Widths, const int _Widths_Size, TRenderAtom* _Parent)/* overload */
		;
	
public:
	int Border;
	Windows::TRect Padding;
	bool HasHeader;
	bool HasFooter;
	bool Clipping;
	__fastcall TRenderTable(const int * _Widths, const int _Widths_Size)/* overload */;
	__fastcall virtual ~TRenderTable(void);
	virtual TRenderAtom* __fastcall Split(int Y, TRenderSplitMode mode);
	virtual void __fastcall Draw(TRenderWriter* Writer, int X, int Y);
	virtual void __fastcall DrawOutline(TRenderWriter* Writer, int X, int Y);
	void __fastcall AdjustFooter(int Y);
	void __fastcall ForceRows(int Index);
	TRenderRow* __fastcall AddRow(void);
	TRenderRow* __fastcall LastRow(void);
	__property TRenderRow* Rows[int Index] = {read=GetRow};
	__property int RowCount = {read=GetRowCount, nodefault};
	__property TRenderCell* Cell[int x][int y] = {read=GetCells/*, default*/};
};


class DELPHICLASS TRenderWord;
class PASCALIMPLEMENTATION TRenderWord : public TRenderAtom 
{
	typedef TRenderAtom inherited;
	
private:
	int FXWidth;
	Graphics::TFont* FFont;
	WideString FWord;
	WideString FAlterWord;
	int FVShift;
	
protected:
	virtual void __fastcall Draw(TRenderWriter* Writer, int X, int Y);
	virtual int __fastcall XWidth(void);
	
public:
	__fastcall TRenderWord(WideString _Word, Graphics::TFont* _Font);
	__fastcall virtual ~TRenderWord(void);
};


class DELPHICLASS TRenderSequence;
class PASCALIMPLEMENTATION TRenderSequence : public TRenderAtom 
{
	typedef TRenderAtom inherited;
	
private:
	TRenderItems* FItems;
	TRenderTextAlign FAlign;
	bool FSplitUp;
	bool FSplitDown;
	virtual int __fastcall GetHeight(void);
	
protected:
	virtual void __fastcall Draw(TRenderWriter* Writer, int X, int Y);
	virtual TRenderAtom* __fastcall Split(int Y, TRenderSplitMode mode);
	
public:
	__fastcall TRenderSequence(WideString _Text, Graphics::TFont* _Font, TRenderTextAlign _Align, AnsiString 
		_Link);
	__fastcall virtual ~TRenderSequence(void);
	void __fastcall AddText(WideString _Text, Graphics::TFont* _Font, AnsiString _Link);
	void __fastcall AddItem(TRenderAtom* _Item);
	void __fastcall NewLine(void);
};


class DELPHICLASS TRenderImage;
class PASCALIMPLEMENTATION TRenderImage : public TRenderAtom 
{
	typedef TRenderAtom inherited;
	
private:
	Graphics::TGraphic* FImage;
	bool FRaster;
	
protected:
	virtual void __fastcall Draw(TRenderWriter* Writer, int X, int Y);
	
public:
	__fastcall TRenderImage(Graphics::TGraphic* _graphic, bool _Raster)/* overload */;
	__fastcall TRenderImage(int _Width, Graphics::TGraphic* _graphic, bool _Raster)/* overload */;
	__fastcall TRenderImage(int _Width, int _Height, Graphics::TGraphic* _graphic, bool _Raster)/* overload */
		;
public:
	#pragma option push -w-inl
	/* TRenderAtom.Destroy */ inline __fastcall virtual ~TRenderImage(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Qpdfrender */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Qpdfrender;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QPDFRender
