// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QPDFTTF.pas' rev: 5.00

#ifndef QPDFTTFHPP
#define QPDFTTFHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <QPDFHash.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qpdfttf
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TFontManager;
class DELPHICLASS TLogicalFont;
class DELPHICLASS TPhysicalFont;
class PASCALIMPLEMENTATION TPhysicalFont : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	HFONT Handle;
	AnsiString Family;
	AnsiString PostScript;
	Qpdfhash::THashInt* UnicodeMap;
	int Style;
	int Descent;
	int FontType;
	__fastcall TPhysicalFont(HFONT _Handle, AnsiString _Family, AnsiString _PostScript, Qpdfhash::THashInt* 
		_UnicodeMap, int _Style, int _Descent, int _FontType);
	__fastcall virtual ~TPhysicalFont(void);
};


class PASCALIMPLEMENTATION TLogicalFont : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	AnsiString Family;
	int Style;
	TPhysicalFont* PhysFont;
	TLogicalFont* OrigFont;
	Qpdfhash::THashInt* UsedChars;
	int SubsetFirst;
	int SubsetCount;
	int InternalIndex;
	AnsiString InternalName;
	bool Embedded;
	__fastcall TLogicalFont(AnsiString _Family, int _Style, TPhysicalFont* _Physical, TLogicalFont* _Original
		);
	__fastcall virtual ~TLogicalFont(void);
};


class PASCALIMPLEMENTATION TFontManager : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	HDC DC;
	HFONT stubFontHandle;
	Classes::TStringStream* pageStream;
	Classes::TStringList* Physicals;
	Classes::TStringList* Families;
	Classes::TStringList* Logicals;
	TLogicalFont* FCurrentFont;
	void __fastcall CreateFontHandle(Windows::PLogFontA logfont);
	void __fastcall SetFontHandle(HFONT _handle);
	HFONT __fastcall RemoveFontHandle(void);
	void __fastcall DeleteFontHandle(void);
	void __fastcall NewPageStream(AnsiString data);
	bool __fastcall OpenTtf(AnsiString name);
	AnsiString __fastcall ReadTtfGlyf(int Offset, int Size);
	void __fastcall SeekTtf(int offs);
	void __fastcall SkipTtf(int offs);
	int __fastcall PosTtf(void);
	int __fastcall SizeTtf(void);
	AnsiString __fastcall ReadTtf(int size);
	AnsiString __fastcall ReadTtfShortString();
	WideString __fastcall ReadTtfUnicode(int size);
	Word __fastcall ReadTtfWord(void);
	unsigned __fastcall ReadTtfDWord(void);
	void __fastcall WriteTtf(const void *data, int Size);
	void __fastcall WriteTtfString(const AnsiString data);
	void __fastcall WriteTtfUnicode(const AnsiString data);
	void __fastcall WriteTtfWord(Word Value);
	void __fastcall WriteTtfDWord(unsigned Value);
	void __fastcall GetPostScriptNames(const int * subset, const int subset_Size, Classes::TStrings* Post
		);
	AnsiString __fastcall ParseTtfNameSection();
	Qpdfhash::THashInt* __fastcall ParseTtfCmapSection(void);
	void __fastcall GenerateTtfSubset(TPhysicalFont* font, const int * subset, const int subset_Size, AnsiString 
		PostScript);
	void __fastcall RegisterFont(Windows::PEnumLogFontExA logfont, AnsiString FaceName, int FontType);
	void __fastcall SetCurrentFont(const TLogicalFont* Value);
	
public:
	__fastcall TFontManager(void);
	__fastcall virtual ~TFontManager(void);
	void __fastcall Reset(void);
	void __fastcall AvailableFontFamilies(Classes::TStrings* _Families);
	void __fastcall SelectFont(AnsiString _Family, bool _Bold, bool _Italic);
	int __fastcall CharWidth(int Code);
	int __fastcall StringWidthW(WideString s);
	int __fastcall StringWidth(AnsiString s);
	Qpdfhash::THashInt* __fastcall AvailableCharacters(void);
	int __fastcall PrepareForEmbedding(void);
	int __fastcall PrepareForNative(void);
	TLogicalFont* __fastcall PreparedFont(int Index);
	void __fastcall GetSubset(TLogicalFont* log, AnsiString &Name, AnsiString &Body, Classes::TStrings* 
		Post, Qpdfhash::THashInt* Widths);
	__property TLogicalFont* CurrentFont = {read=FCurrentFont, write=SetCurrentFont};
};


class DELPHICLASS TPhysicalFamily;
class PASCALIMPLEMENTATION TPhysicalFamily : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	AnsiString Family;
	TPhysicalFont* Physical[4];
	__fastcall TPhysicalFamily(AnsiString _Family);
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TPhysicalFamily(void) { }
	#pragma option pop
	
};


class DELPHICLASS TFontFace;
class PASCALIMPLEMENTATION TFontFace : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	AnsiString Name;
	int FontType;
	#pragma pack(push, 1)
	tagLOGFONTA logfont;
	#pragma pack(pop)
	
public:
	#pragma option push -w-inl
	/* TObject.Create */ inline __fastcall TFontFace(void) : System::TObject() { }
	#pragma option pop
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TFontFace(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TFontManager* FontManager;
extern PACKAGE Contnrs::TObjectList* SystemFontFaces;
static const Byte MAXSUBSET = 0xff;
extern PACKAGE Graphics::TFont* __fastcall FontFromDC(HDC dc);
extern PACKAGE int __fastcall FontStyleFromFlags(bool Bold, bool Italic);
extern PACKAGE void __fastcall EnumerateSystemFonts(void);

}	/* namespace Qpdfttf */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Qpdfttf;
#endif
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QPDFTTF
