// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QPDFFrontEnd.pas' rev: 6.00

#ifndef QPDFFrontEndHPP
#define QPDFFrontEndHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Dialogs.hpp>	// Pascal unit
#include <jpeg.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <QPDFHash.hpp>	// Pascal unit
#include <QPDFTTF.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Qpdffrontend
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TPdfObject;
class DELPHICLASS TPdfContext;
class DELPHICLASS TPdfDictionary;
class PASCALIMPLEMENTATION TPdfObject : public System::TObject 
{
	typedef System::TObject inherited;
	
protected:
	TPdfContext* FContext;
	AnsiString FStringContent;
	int FRefID;
	TPdfObject* FParent;
	
public:
	__fastcall TPdfObject(void)/* overload */;
	__fastcall TPdfObject(AnsiString value)/* overload */;
	__fastcall TPdfObject(int value)/* overload */;
	__fastcall TPdfObject(Extended value)/* overload */;
	void __fastcall Fatal(AnsiString msg);
	virtual void __fastcall Print(void);
	virtual void __fastcall PrintFull(void);
	void __fastcall PrintRef(void);
	AnsiString __fastcall GetRef();
	__property TPdfContext* Context = {read=FContext};
public:
	#pragma option push -w-inl
	/* TObject.Destroy */ inline __fastcall virtual ~TPdfObject(void) { }
	#pragma option pop
	
};


class PASCALIMPLEMENTATION TPdfDictionary : public TPdfObject 
{
	typedef TPdfObject inherited;
	
public:
	TPdfObject* operator[](AnsiString Index) { return Items[Index]; }
	
private:
	Classes::TStringList* FDict;
	TPdfObject* __fastcall GetItems(AnsiString Index);
	void __fastcall SetItems(AnsiString Index, const TPdfObject* Value);
	bool __fastcall Find(AnsiString name, int &Index);
	
public:
	__fastcall TPdfDictionary(void)/* overload */;
	__fastcall TPdfDictionary(AnsiString typ)/* overload */;
	__fastcall TPdfDictionary(const System::TVarRec * arr, const int arr_Size)/* overload */;
	__fastcall virtual ~TPdfDictionary(void);
	virtual void __fastcall Print(void);
	virtual void __fastcall PrintFull(void);
	void __fastcall Add(AnsiString name, TPdfObject* obj)/* overload */;
	void __fastcall Add(const System::TVarRec * arr, const int arr_Size)/* overload */;
	__property TPdfObject* Items[AnsiString Index] = {read=GetItems, write=SetItems/*, default*/};
};


class DELPHICLASS TPdfArray;
class PASCALIMPLEMENTATION TPdfArray : public TPdfObject 
{
	typedef TPdfObject inherited;
	
public:
	TPdfObject* operator[](int Index) { return Items[Index]; }
	
private:
	Contnrs::TObjectList* FArray;
	TPdfObject* __fastcall GetItems(int Index);
	
public:
	__fastcall TPdfArray(void)/* overload */;
	__fastcall TPdfArray(const System::TVarRec * arr, const int arr_Size)/* overload */;
	__fastcall virtual ~TPdfArray(void);
	virtual void __fastcall PrintFull(void);
	void __fastcall Add(TPdfObject* obj)/* overload */;
	void __fastcall Add(const System::TVarRec * arr, const int arr_Size)/* overload */;
	int __fastcall Count(void);
	__property TPdfObject* Items[int Index] = {read=GetItems/*, default*/};
};


class DELPHICLASS TPdfPage;
class DELPHICLASS TPdfStream;
class PASCALIMPLEMENTATION TPdfStream : public TPdfDictionary 
{
	typedef TPdfDictionary inherited;
	
private:
	Classes::TStringStream* FStream;
	
public:
	__fastcall TPdfStream(void)/* overload */;
	__fastcall TPdfStream(AnsiString typ)/* overload */;
	__fastcall TPdfStream(const System::TVarRec * arr, const int arr_Size)/* overload */;
	__fastcall virtual ~TPdfStream(void);
	virtual void __fastcall Print(void);
	virtual void __fastcall PrintFull(void);
	void __fastcall Write(AnsiString str);
	void __fastcall WriteFmt(AnsiString str, const System::TVarRec * args, const int args_Size);
};


class PASCALIMPLEMENTATION TPdfPage : public TPdfStream 
{
	typedef TPdfStream inherited;
	
private:
	bool FMetaPathActive;
	int FMetaJoinStyle;
	int FMetaCapStyle;
	#pragma pack(push, 1)
	Types::TRect FMetaRect;
	#pragma pack(pop)
	
	#pragma pack(push, 1)
	Types::TRect FMetaFrame;
	#pragma pack(pop)
	
	#pragma pack(push, 1)
	Types::TPoint FMetaExt;
	#pragma pack(pop)
	
	Contnrs::TObjectList* FWords;
	int FCurFillColor;
	int FCurStrokeColor;
	int FCurLineWidth;
	#pragma pack(push, 1)
	Types::TPoint FPageSize;
	#pragma pack(pop)
	
	int __fastcall GetPageHeight(void);
	int __fastcall GetPageWidth(void);
	
public:
	__fastcall TPdfPage(const Types::TPoint &_PageSize);
	__fastcall virtual ~TPdfPage(void);
	void __fastcall AddWordW(WideString Word, int x, int y);
	void __fastcall AddWord(AnsiString Word, int x, int y);
	void __fastcall WriteMetaFile(int x, int y, int width, int height, unsigned emf);
	void __fastcall ProcessMetaRecord(HDC dc, Windows::PHandleTable ht, Windows::PEnhMetaRecord rec, int nobj);
	void __fastcall WriteLine(int left, int top, int width, int height);
	void __fastcall WriteRect(int left, int top, int width, int height);
	void __fastcall WriteArc(int left, int top, int width, int height);
	void __fastcall WriteFillRect(int left, int top, int width, int height);
	void __fastcall WriteFillColor(int color);
	void __fastcall WriteStrokeColor(int color);
	void __fastcall WriteStrokeWidth(int width);
	void __fastcall WriteImage(int left, int top, int width, int height, Graphics::TGraphic* graphic, bool raster);
	void __fastcall SetClip(int x, int y, int width, int height);
	void __fastcall RemoveClip(void);
	__property int PageHeight = {read=GetPageHeight, nodefault};
	__property int PageWidth = {read=GetPageWidth, nodefault};
};


class PASCALIMPLEMENTATION TPdfContext : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Classes::TStream* FStream;
	Contnrs::TObjectList* FObjects;
	Contnrs::TObjectList* FIndirects;
	TPdfDictionary* FCatalog;
	TPdfDictionary* FDocInfo;
	TPdfDictionary* FPageTree;
	TPdfArray* FPages;
	TPdfArray* FXObjects;
	TPdfDictionary* FTrailer;
	TPdfDictionary* FCrypt;
	TPdfDictionary* FCurPage;
	TPdfPage* FCurContent;
	#pragma pack(push, 1)
	Types::TPoint FPageSize;
	#pragma pack(pop)
	
	int FCurFontHeight;
	int FCurFontBaseLine;
	int FCurTextColor;
	Classes::TStringList* FLinks;
	AnsiString FEncryptKey;
	TPdfArray* __fastcall GetLinkData(AnsiString Name);
	int __fastcall GetPageHeight(void);
	int __fastcall GetPageWidth(void);
	
public:
	__fastcall TPdfContext(Classes::TStream* stream, int width, int height, int KeyLength, int ACL, AnsiString OwnerPassword, AnsiString UserPassword);
	__fastcall virtual ~TPdfContext(void);
	void __fastcall SetDocInfo(AnsiString Producer, AnsiString Creator, AnsiString Title, AnsiString Author, AnsiString Subject, AnsiString Keywords);
	void __fastcall SetLink(AnsiString Link, const Types::TRect &Bounds);
	void __fastcall ResolveLink(AnsiString Link, int x, int y);
	void __fastcall AddContentsLink(AnsiString Title, AnsiString Link, int Level = 0x0);
	void __fastcall AddObj(System::TObject* obj);
	int __fastcall AddRef(System::TObject* obj);
	void __fastcall Write(AnsiString value);
	void __fastcall Writeln(AnsiString value);
	void __fastcall SetFont(Graphics::TFont* Font)/* overload */;
	TPdfPage* __fastcall AddPage(void);
	__property TPdfPage* Page = {read=FCurContent};
	int __fastcall StringWidth(WideString str);
	void __fastcall Generate(bool AEmbedded);
	__property int CurTextColor = {read=FCurTextColor, write=FCurTextColor, nodefault};
	__property int PageHeight = {read=GetPageHeight, nodefault};
	__property int PageWidth = {read=GetPageWidth, nodefault};
};



class DELPHICLASS TPdfImage;
class PASCALIMPLEMENTATION TPdfImage : public TPdfStream 
{
	typedef TPdfStream inherited;
	
private:
	Graphics::TGraphic* FGraphic;
	
public:
	__fastcall TPdfImage(Graphics::TGraphic* _Image);
	__property Graphics::TGraphic* Graphic = {read=FGraphic};
public:
	#pragma option push -w-inl
	/* TPdfStream.Destroy */ inline __fastcall virtual ~TPdfImage(void) { }
	#pragma option pop
	
};


class DELPHICLASS TPdfJpeg;
class PASCALIMPLEMENTATION TPdfJpeg : public TPdfImage 
{
	typedef TPdfImage inherited;
	
public:
	__fastcall TPdfJpeg(Jpeg::TJPEGImage* _Image);
public:
	#pragma option push -w-inl
	/* TPdfStream.Destroy */ inline __fastcall virtual ~TPdfJpeg(void) { }
	#pragma option pop
	
};


class DELPHICLASS TPdfBitmap;
class PASCALIMPLEMENTATION TPdfBitmap : public TPdfImage 
{
	typedef TPdfImage inherited;
	
public:
	__fastcall TPdfBitmap(Graphics::TGraphic* _Image);
public:
	#pragma option push -w-inl
	/* TPdfStream.Destroy */ inline __fastcall virtual ~TPdfBitmap(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------
extern PACKAGE TPdfContext* PdfContext;
extern PACKAGE void __fastcall (*debug)(const AnsiString str, const System::TVarRec * prm, const int prm_Size);
extern PACKAGE void __fastcall _debug(const AnsiString str, const System::TVarRec * prm, const int prm_Size);

}	/* namespace Qpdffrontend */
using namespace Qpdffrontend;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QPDFFrontEnd
