// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'QuickPdf.pas' rev: 6.00

#ifndef QuickPdfHPP
#define QuickPdfHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <Contnrs.hpp>	// Pascal unit
#include <QPDFFrontEnd.hpp>	// Pascal unit
#include <QPDFRender.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Quickpdf
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TQuickPdfSecurityMode { secDisabled, sec40bit, sec128bit };
#pragma option pop

#pragma option push -b-
enum QuickPdf__1 { secPrint, secExtraction, secModify };
#pragma option pop

typedef Set<QuickPdf__1, secPrint, secModify>  TQuickPdfSecurityOptions;

class DELPHICLASS TQuickPdf;
class DELPHICLASS TQuickPdfDocument;
class DELPHICLASS TQuickPdfPageInfo;
class PASCALIMPLEMENTATION TQuickPdfDocument : public System::TObject 
{
	typedef System::TObject inherited;
	
private:
	Qpdfrender::TRenderTable* FTable;
	int FWidth;
	Qpdfrender::TRenderCell* __fastcall GetFooter(void);
	Qpdfrender::TRenderCell* __fastcall GetHeader(void);
	Qpdfrender::TRenderCell* __fastcall GetSection(int Index);
	void __fastcall Clear(void);
	void __fastcall Start(TQuickPdfPageInfo* page);
	
public:
	__fastcall TQuickPdfDocument(void);
	__fastcall virtual ~TQuickPdfDocument(void);
	void __fastcall SetMargins(int left, int top, int right, int bottom);
	__property Qpdfrender::TRenderCell* Section[int Index] = {read=GetSection};
	__property Qpdfrender::TRenderCell* Header = {read=GetHeader};
	__property Qpdfrender::TRenderCell* Footer = {read=GetFooter};
	__property Qpdfrender::TRenderTable* MainTable = {read=FTable};
};


class DELPHICLASS TQuickPdfContentsItem;
class PASCALIMPLEMENTATION TQuickPdfContentsItem : public System::TObject 
{
	typedef System::TObject inherited;
	
public:
	TQuickPdfContentsItem* operator[](int Index) { return Items[Index]; }
	
private:
	TQuickPdfContentsItem* FParent;
	Contnrs::TObjectList* FItems;
	int __fastcall GetCounter(void);
	TQuickPdfContentsItem* __fastcall GetItem(int Index);
	
protected:
	__fastcall TQuickPdfContentsItem(void)/* overload */;
	__fastcall TQuickPdfContentsItem(AnsiString ATitle, AnsiString ALink, TQuickPdfContentsItem* AParent)/* overload */;
	
public:
	AnsiString Title;
	AnsiString Link;
	__fastcall virtual ~TQuickPdfContentsItem(void);
	void __fastcall Clear(void);
	TQuickPdfContentsItem* __fastcall Add(AnsiString ATitle, AnsiString ALink);
	__property int Count = {read=GetCounter, nodefault};
	__property TQuickPdfContentsItem* Parent = {read=FParent, write=FParent};
	__property TQuickPdfContentsItem* Items[int Index] = {read=GetItem/*, default*/};
};


class PASCALIMPLEMENTATION TQuickPdf : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	AnsiString FFileName;
	TQuickPdfDocument* FDocument;
	TQuickPdfContentsItem* FContents;
	bool FEmbedded;
	TQuickPdfPageInfo* FPageInfo;
	AnsiString FAuthor;
	AnsiString FTitle;
	AnsiString FCreator;
	AnsiString FKeywords;
	AnsiString FSubject;
	TQuickPdfSecurityMode FSecurity;
	AnsiString FOwnerPassword;
	AnsiString FUserPassword;
	TQuickPdfSecurityOptions FSecurityOptions;
	TQuickPdfDocument* __fastcall GetDocument(void);
	
public:
	__fastcall virtual TQuickPdf(Classes::TComponent* AOwner);
	__fastcall virtual ~TQuickPdf(void);
	void __fastcall GenerateToStream(Classes::TStream* stream);
	void __fastcall GenerateToFile(void);
	AnsiString __fastcall GenerateToString();
	__property TQuickPdfDocument* Document = {read=GetDocument};
	__property TQuickPdfContentsItem* Contents = {read=FContents};
	void __fastcall Clear(void);
	
__published:
	__property bool EmbeddedFonts = {read=FEmbedded, write=FEmbedded, default=1};
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property TQuickPdfPageInfo* PageInfo = {read=FPageInfo, write=FPageInfo};
	__property AnsiString PdfAuthor = {read=FAuthor, write=FAuthor};
	__property AnsiString PdfTitle = {read=FTitle, write=FTitle};
	__property AnsiString PdfCreator = {read=FCreator, write=FCreator};
	__property AnsiString PdfSubject = {read=FSubject, write=FSubject};
	__property AnsiString PdfKeywords = {read=FKeywords, write=FKeywords};
	__property TQuickPdfSecurityMode Security = {read=FSecurity, write=FSecurity, nodefault};
	__property AnsiString SecurityUserPassword = {read=FUserPassword, write=FUserPassword};
	__property AnsiString SecurityOwnerPassword = {read=FOwnerPassword, write=FOwnerPassword};
	__property TQuickPdfSecurityOptions SecurityOptions = {read=FSecurityOptions, write=FSecurityOptions, nodefault};
};


#pragma option push -b-
enum TQuickPdfPageSize { psCustom, psA4, psLetter, psLegal };
#pragma option pop

class PASCALIMPLEMENTATION TQuickPdfPageInfo : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	int FHeight;
	int FMarginLeft;
	int FWidth;
	int FMarginRight;
	int FMarginTop;
	int FMarginBottom;
	TQuickPdfPageSize FSize;
	void __fastcall SetSize(const TQuickPdfPageSize Value);
	void __fastcall SetWidth(int Value);
	void __fastcall SetHeight(int Value);
	void __fastcall SetMarginLeft(int Value);
	void __fastcall SetMarginRight(int Value);
	void __fastcall SetMarginTop(int Value);
	void __fastcall SetMarginBottom(int Value);
	
protected:
	virtual void __fastcall AssignTo(Classes::TPersistent* Dest);
	
__published:
	__fastcall TQuickPdfPageInfo(void);
	__property TQuickPdfPageSize Size = {read=FSize, write=SetSize, nodefault};
	__property int Width = {read=FWidth, write=SetWidth, nodefault};
	__property int Height = {read=FHeight, write=SetHeight, nodefault};
	__property int MarginLeft = {read=FMarginLeft, write=SetMarginLeft, nodefault};
	__property int MarginRight = {read=FMarginRight, write=SetMarginRight, nodefault};
	__property int MarginTop = {read=FMarginTop, write=SetMarginTop, nodefault};
	__property int MarginBottom = {read=FMarginBottom, write=SetMarginBottom, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TQuickPdfPageInfo(void) { }
	#pragma option pop
	
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Quickpdf */
using namespace Quickpdf;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// QuickPdf
